#!/bin/bash
DIR="$PWD/pm9a1"

for MODEL in MZVL2256HCHQ-00B00 MZVL2512HCJQ-00B00 MZVL21T0HCLR-00B00 MZVL22T0HBLB-00B00; do

  case "$MODEL" in
    MZVL2256HCHQ-00B00|MZVL2512HCJQ-00B00|MZVL21T0HCLR-00B00)
      FWREV="GXA7601Q"
      ;;
    MZVL22T0HBLB-00B00)
      FWREV="GXB7601Q"
      ;;
  esac

  FWFILE="${DIR}/${FWREV}_Noformat.bin"

  if [ -n "$1" ] && [ -b "$1" ]; then
    drive=$1
    if nvme id-ctrl $drive|grep "$MODEL" >/dev/null 2>&1; then
      echo "found $MODEL: $drive, starting firmware update to $FWREV"
      if nvme id-ctrl $drive|grep "$FWREV" >/dev/null 2>&1; then
        echo "$drive is already on the latest firmware"
      elif nvme fw-download $drive --fw=$FWFILE; then
        nvme fw-commit $drive -s 2 -a 1
      else
        echo "fw-download failed for $drive"
      fi
    fi
  elif [ -e /dev/nvme0 ]; then
    for drive in /dev/nvme?; do
      if nvme id-ctrl $drive|grep "$MODEL" >/dev/null 2>&1; then
        echo "found $MODEL: $drive, starting firmware update to $FWREV"
        if nvme id-ctrl $drive|grep "$FWREV" >/dev/null 2>&1; then
          echo "$drive is already on the latest firmware"
        elif nvme fw-download $drive --fw=$FWFILE; then
          nvme fw-commit $drive -s 2 -a 1
        else
          echo "fw-download failed for $drive"
        fi
      fi
    done
  fi
done
